#include<stdio.h>
#include<stdlib.h>
#include<math.h>

/*******************************************************************/
/*   this is the program for calculating the beam position         */
/*   on the crystal.                                               */
/*******************************************************************/
double  Beam_Position_x( float x1 , float x2, float x3 , float x4 )
{
#define n 4            /* the number of MWPC */
#define distance 9741  /* the distance from the origine to the front face of the crystal */
  double MWPC_1x[4] = {0,0.0,1663.,2314.5};      
  double MWPC_2x[4] = {0,0.0,1663.,6649.0};    
  double MWPC_3x[4] = {0,0.0,1663.,9166.0};  
  double MWPC_4x[4] = {0,0.0,1663.,8979.0};  
  double sum1,sum2,sum3,sum4,grad_x,dx;
  double position_1x,position_2x,position_3x,position_4x;
  double x_position;
  /*  2mm interval  */
  position_1x = ( x1 )*2 - ( 24.5 * 2 ) + MWPC_1x[1];
  position_2x = ( x2 )*2 - ( 24.5 * 2 ) + MWPC_2x[1];
  position_3x = ( x3 )*2 - ( 24.5 * 2 ) + MWPC_3x[1];
  position_4x = ( x4 )*2 - ( 32.5 * 2 ) + MWPC_4x[1];
  
  sum1 = (MWPC_1x[3]*position_1x)+(MWPC_2x[3]*position_2x)+(MWPC_3x[3]*position_3x)+(MWPC_4x[3]*position_4x);
  sum2 = (MWPC_1x[3]+MWPC_2x[3]+MWPC_3x[3]+MWPC_4x[3]);
  sum3 = (position_1x+position_2x+position_3x+position_4x);
  sum4 = (MWPC_1x[3]*MWPC_1x[3])+(MWPC_2x[3]*MWPC_2x[3])+(MWPC_3x[3]*MWPC_3x[3])+(MWPC_4x[3]*MWPC_4x[3]);
  grad_x = ( (n*sum1) - (sum2*sum3) )/( (n*sum4) - (sum2*sum2) );
  dx = ( (sum4*sum3) - (sum2*sum1) )/( (n*sum4) - (sum2*sum2) );
  x_position = (grad_x)*distance + dx;
  
  return x_position;
}

double  Beam_Position_y( float y1, float y2, float y3 , float y4 )
{
#define n 4
#define distance 9741  /* the distance from origine to face of crystal */
  double MWPC_1y[4] = {0,0.0,1663.,2332.5};     
  double MWPC_2y[4] = {0,0.0,1663.,6631.0};    
  double MWPC_3y[4] = {0,0.0,1663.,9184.0};  
  double MWPC_4y[4] = {0,0.0,1663.,8969.0};  
  
  double sum5,sum6,sum7,sum8,grad_y,dy;
  double position_1y,position_2y,position_3y,position_4y;
  double y_position;
  
  position_1y = -( y1 )*2 + ( 24.5 * 2 ) + MWPC_1y[2];
  position_2y = -( y2 )*2 + ( 24.5 * 2 ) + MWPC_2y[2];
  position_3y = -( y3 )*2 + ( 24.5 * 2 ) + MWPC_3y[2];
  position_4y = -( y4 )*2 + ( 32.5 * 2 ) + MWPC_4y[2];
  
  sum5 = (MWPC_1y[3]*position_1y)+(MWPC_2y[3]*position_2y)+(MWPC_3y[3]*position_3y)+(MWPC_4y[3]*position_4y);
  sum6 = (MWPC_1y[3]+MWPC_2y[3]+MWPC_3y[3]+MWPC_4y[3]);
  sum7 = (position_1y+position_2y+position_3y+position_4y);
  sum8 = (MWPC_1y[3]*MWPC_1y[3])+(MWPC_2y[3]*MWPC_2y[3])+(MWPC_3y[3]*MWPC_3y[3])+(MWPC_4y[3]*MWPC_4y[3]);
  grad_y = ( (n*sum5) - (sum6*sum7) )/( (n*sum8) - (sum6*sum6) );
  dy = ( (sum8*sum7) - (sum6*sum5) )/( (n*sum8) - (sum6*sum6) );
  y_position = (grad_y)*distance + dy;
  
  return y_position;
}
